﻿package
{
	
	import demo.app.model.vo.PolyShapeVO;
	import demo.app.view.ShapeEnvironment;
	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.MouseEvent;
	import demo.utils.FrameRateCounter;
	import flash.events.Event;
	import flash.events.AccelerometerEvent;
	import flash.sensors.Accelerometer;
	import flash.text.TextField;
	import flash.text.TextFormat;
	//import flash.desktop.NativeApplication;
	//import flash.desktop.SystemIdleMode;
	
	public class Box2D extends Sprite
	{
		private var _colors:Array = new Array(0xFF0000, 0xFFFF00, 0x00FF00, 0x00FFFF, 0x0000FF);
		private var _shape2d:demo.app.view.ShapeEnvironment;
		private var _output:TextField;
		private var _accelerometer:Accelerometer;
		
		public function Box2D()
		{		
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			var background:Sprite = new Sprite();
			background.graphics.lineStyle(20, 0x000000);
			background.graphics.drawRect(0,0,480,800);
			this.addChild(background);
			
			_shape2d = new ShapeEnvironment(460,780);
			_shape2d.x = 10;
			_shape2d.y = 10;
			
			_shape2d.start();
			
			this.addChild(_shape2d);

			_output = new TextField();
			
			_output.width = 480;
			_output.y = 50;
			_output.defaultTextFormat = new TextFormat(null, 16);
			this.addChild(_output);
			
			//stage.addEventListener(Event.RESIZE, onChanged, false, 0, true);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, addCounterGravity, false, 0, true);
			stage.addEventListener(MouseEvent.MOUSE_UP, removeCounterGravity, false, 0, true);
			
			var framerateCounter:FrameRateCounter = new FrameRateCounter();
			framerateCounter.x = 10;
			framerateCounter.y = 10;
			addChild(framerateCounter);
			
			_accelerometer = new Accelerometer();
			_accelerometer.addEventListener(AccelerometerEvent.UPDATE, onChanged);
			
		}
		

		private function onChanged(evt:AccelerometerEvent):void{
			_shape2d.gravityX = -evt.accelerationX * 10;
			_shape2d.gravityY = evt.accelerationY * 10;
		}
		
		private function addCounterGravity(event:MouseEvent):void
		{
			//_shape2d.counterGravity = true;
			var tempShapeVO:PolyShapeVO = new PolyShapeVO();
			tempShapeVO.color = _colors[0];
			tempShapeVO.numSides = 4;
			tempShapeVO.radius = 36;
			tempShapeVO.xPos = this.mouseX;
			tempShapeVO.yPos = this.mouseY;
			_shape2d.addPoly(tempShapeVO);
		}
		
		private function removeCounterGravity(event:MouseEvent):void
		{
			//_shape2d.counterGravity = false;
		} 
	}
}